      subroutine laplacian1(n,h,l,r,wfn,del2wfn,dum1,dum2)
      implicit real*8 (a-h,o-z)
! on input: wfn(i) is radial wfn * r for angular momentum l
! on output: del2wfn is r*(d2/dr2-l*(l+1)/r^2)wfn
      dimension r(n),wfn(n),del2wfn(n),dum1(n),dum2(n)
!  factor out r
      lfac=l*(l+1)
      do i=1,n
      dum2(i)=wfn(i)/r(i)
      del2wfn(i)=-lfac*dum2(i)
      enddo
      call nderiv(h,dum2,dum1,n)
      del2wfn(:)=del2wfn(:)+2*r(:)*dum1(:)
      call nderiv(h,dum1,dum2,n)
      del2wfn(:)=del2wfn(:)+(r(:)**2)*dum2(:)
      return
      end
 
